﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.IO;
using System.IO.Compression;


namespace deco2pos
{
    class Deco2pos
    {
        [STAThread]
        static void Main(string[] args)
        {
            subp subproc = new subp();
            subproc.MProc();
        }
    }


    class subp
    {
        public string infile = "";
        public string infile2 = "";
        public StringBuilder stdump;
        public byte[] posdarry = null;

        public void MProc()
        {
            string[] files = System.Environment.GetCommandLineArgs();

            if (2 > files.Length)
            {
                Console.WriteLine("decoファイルをドロップしてください。");
                Console.WriteLine("decoを生成したposファイルは、decoファイルと同じフォルダに入れておいてください。");
                Prsend();
            }
            int fid = 0; stdump = new StringBuilder(10000);
            if (Directory.Exists(files[1]))
            {
                string[] drfile = Directory.GetFiles(files[1], "*");
                foreach (string ifile in drfile)
                { infile = ifile; Proc(ref fid); }
            }
            else
            {
                for (int i = 0; i < files.Length; i++)
                { infile = files[i]; Proc(ref fid); }
            }

            //もともとのPOSさがすよー
            string stAfterName1 = Path.ChangeExtension(files[1], null);
            string stAfterName2 = Path.ChangeExtension(stAfterName1, null);

            infile2 = Path.ChangeExtension(stAfterName2, ".pos");

            if (File.Exists(infile2))
            { Integratefile(ref fid); }
            else fid = 0; //元POSないから変換しないねー

            if (0 < fid)
            {
                Console.WriteLine(fid.ToString() + "ファイルを変換");
            }
            else
            { Console.WriteLine("\n変換できるファイルがありません"); }
            Prsend();
        }

        private void Integratefile(ref int fid)
        {
            byte[] barr; int hadr = 0;

            barr = File.ReadAllBytes(@infile2);

            uint ck = BitConverter.ToUInt16(barr, hadr);

            //PNGのヘッダーまでいくよー（途中に偶然0x9c78あるかもしれないけどｗ
            while (0x9c78 != ck)
            {
                hadr++;
                ck = BitConverter.ToUInt16(barr, hadr);
            }

            //Lengthのデータまでもどるよー
            hadr -= 4;

            //次の0x9c78近辺まで飛ぶよー
            hadr += BitConverter.ToInt32(barr, hadr);
            ck = BitConverter.ToUInt16(barr, hadr);

            //PosDatのヘッダーまでいくよー（途中に偶然0x9c78あるかもしれないけどｗ
            //めんどくさいんでベタコードｗｗ
            while (0x9c78 != ck)
            {
                hadr++;
                ck = BitConverter.ToUInt16(barr, hadr);
            }

            //Lengthのデータまでもどるよー
            hadr -= 4;

            //ファイル統合するよー
            Byte[] BufArry = new Byte[hadr + posdarry.Length];
            //Array.Copy(ary1, 2, ary2, 0, 5); ary1の2～5のデータをary2の0項目以降へ書き込む
            Array.Copy(barr, 0, BufArry, 0, hadr);
            Array.Copy(posdarry, 0, BufArry, hadr, posdarry.Length);

            //ファイル作って書き込んじゃうよー
            string outfile = Path.ChangeExtension(infile2, ".deco.pos");

            
            try
            {
                Console.WriteLine(outfile + "へ出力します");
                File.WriteAllBytes(@outfile, BufArry);
            }
            catch
            {
                Console.WriteLine("File Write Error:");
                fid = 0;
                return;
            }
        }

        private void Proc(ref int fid)
        {
            if (null == infile || "" == infile) return;
            string fext = Path.GetExtension(infile).ToLower();
            if (".exe" == fext || ".pos" == fext || ".png" == fext) return;
            if (0 < VtxDeco()) fid++;
        }

        static void Prsend()
        {
            Console.WriteLine("\n何かキーを押すとこの画面を抜けます");
            Console.ReadKey();
            Environment.Exit(0);
        }


        private int VtxDeco()
        {
            byte[] barr; int hadr = 0;
            
            UInt32 s1, s2, adler;
            Byte[] adcksm = new Byte[4];

            barr = File.ReadAllBytes(@infile);
            //if (9 > barr.Length) return 1;
            stdump.Append(infile + "\n");

            s1 = 1;
            s2 = 0;

            while (hadr < barr.Length)
            {
                s1 += barr[hadr];
                s1 %= 65521;
                
                s2 += s1;
                s2 %= 65521;

                hadr ++; 
                if (0 > hadr) break;
            }

            adler = (s2 << 16) + s1;
            
            BitConverter.GetBytes(adler).CopyTo(adcksm, 0);
            Array.Reverse(adcksm, 0, 4);

            //ここで圧縮してるよー
            try
            {
                MemoryStream ms = new MemoryStream();
                DeflateStream ds = new DeflateStream(ms, CompressionMode.Compress,true);
                ds.Write(barr, 0, barr.Length);
                ds.Close();
                byte[] compressData = ms.ToArray();

                ds.Close();
                ms.Close();

                //Length+Header+compressData+Adlerの配列作り
                posdarry = new byte[compressData.Length + 10];
                    //compressData.Length + 10 = Lengthも含めたHeader+compressData+Adlerの数
                BitConverter.GetBytes(compressData.Length + 6).CopyTo(posdarry, 0);
                    //compressData.Length + 6 = Lengthを抜かしたHeader+compressData+Adlerの数＝　TSXBINでのZDLen
                posdarry[4] = 0x78;
                posdarry[5] = 0x9C;
                //書式：Array.Copy(ary2, 0, ary1, aryLen（開始位置っぽい）, ary2.Length);
                Array.Copy(compressData, 0, posdarry, 6, compressData.Length);
                Array.Copy(adcksm, 0, posdarry, posdarry.Length - 4, adcksm.Length);
            }
            catch { return 0; }
            return 1;
                
        }
    }
}
